      program pf2GMT

!  gfortran -O3 -o pf2GMT pf2GMT.f

      implicit none

!     This program reads in .SOD and .COD files and
!     convert to GMT input format (multiple files)

!     This program is made available on the understanding that its
!     use will be appropriately acknowledged.  No warranty of any
!     kind is avaiable.  Please inform tony rollett of any errors that
!     you find: rollett@andrew.cmu.edu
!     ADR   March 2004
!  added a line to convert zero to one, to avoid jagged lines in GMT plots, v 10

      integer mm,mm2,kk,k,ntype,j,i
      parameter (mm=45)         !  must be >=37 and ODD
      real fint(73,20,20)
      real xcent,ycent,radius,pi,pi2,pi4,nscalee
      real scint(0:6),scleg(0:6),scleg2(0:6)
      integer nvint(73,20,20)
      character afile*80, file*79, out1*22, outfile*80

      real array(mm,mm),cval(0:10),xold,yold,xdiff,ydiff,xorig,yorig
      real colrval(3,0:10)
      integer iarray(mm,mm)
      real greyval(0:10)
c     colors are in COLRVAL
      integer nval
      character*5 nomen,seclab,label
      real delth,rm,delom,pm
      integer iw,jw,iper(3),iavg,ngr
      logical rescale,complete
      integer kazimuth,ulimit
      real degrad
      integer pole(3)
      real wdth,rmax,SMF(mm,(-1*mm):mm)
      integer ix,iy,ix2,iy2
      integer numpolefigs
      character polechar*25
      character title*132,digit*1
      real scalef,new_scale
      integer intmax
      character outline*132
      character extension*3  ! filename extension
      real ymin,ymax,yave
      integer count
      real capphi,oldcapphi,newcapphi,darea(19),tota

c     CODE::
      mm2 = ((mm-1)/2)+1          ! e.g. mm=37->mm2=19
      pi = 4.*atan(1.)
      pi2 = 2.*atan(1.)
      pi4 = atan(1.)
      degrad = 180./pi

      tota = 0.
      oldcapphi = 0.
      do i = 1,19
         capphi = float(i-1)*5.0
         newcapphi = capphi+2.5
         newcapphi = amin1(newcapphi,90.0)
         darea(i) = cos(oldcapphi/degrad)-cos(newcapphi/degrad)
         tota = tota + darea(i)
         oldcapphi = newcapphi
      enddo
!      print*,'total area = ',tota

      print *,' '
      print *,' example of usage:  ./pf2GMT demo.epf'

      CALL GetArg(1, afile)

c     print *,'Name of input file (.epf, .PPF, .APF or .PWF) ?'
c     read(*,1011) afile
 1011 format(a)
!      print *,' '

      kk=20
      do  i = 80,1,-1
         if(afile(i:i).eq.'.') then
            kk=i
            extension = afile(i+1:i+3)
            goto 154
         endif
      enddo
 154  continue
      file=afile(kk+1:kk+3)
      if(file.eq.'apf'.or.file.eq.'APF'
     1     .or.file.eq.'wpf'.or.file.eq.'WPF'
     2     .or.file.eq.'ppf'.or.file.eq.'PPF'
     3     .or.file.eq.'fpf'.or.file.eq.'FPF'
     4     .or.file.eq.'mpf'.or.file.eq.'MPF'
     5     .or.file.eq.'cmb'.or.file.eq.'CMB'
     6     .or.file.eq.'rpf'.or.file.eq.'RPF'
     7     .or.file.eq.'ipf'.or.file.eq.'IPF'
     8     .or.file.eq.'dif'.or.file.eq.'DIF'
     9     .or.file.eq.'raw'.or.file.eq.'RAW'
     &     .or.file.eq.'wip'.or.file.eq.'WIP'
     &     .or.file.eq.'tpf'.or.file.eq.'TPF'  !  tilted PFs
     &     .or.file.eq.'hpf'.or.file.eq.'HPF'  !  harmonic PFs
     &     .or.file.eq.'epf'.or.file.eq.'EPF') then
         ntype=1
         goto 888
      end if
      write(*,*)'This converts only epf, wpf, apf, 
     & fpf, wip, tpf, hpf or ppf files'
      call exit(1)

 888  continue

      open(11,file=afile,status='old')

      do k = 1,9                !  maximum of 9 pole figures

         ymin = 1.e33
         ymax = 0.
         yave = 0.
         count = 0
         print*
         write(*,*) 'About to read PF number ',k
         complete=.false.
         read(11,"(a)",err=932,end=804) title
         write(*,*) title
         
         intmax = 0
         write(digit,"(i1)") k
c     outfile=afile(1:(kk-1))//'.pf'//digit
         outfile=afile(1:(kk-1))//'_'//extension//digit//'.gpf'
         write(*,*) 'Writing ',outfile,' as output filename'
         open(12,file=outfile,status='unknown')

         read(11,1332,err=932) nomen,delth,rm,delom,pm,iw,jw
     &        ,(iper(i),i=1,3),iavg,ngr,seclab,label
 1332    format(a5,4f5.1,5i2,2i5,2a5)
! 1332    format(1x,i3,1x,4f5.1,5i2,2i5,2a5)
c$$$         write(*,"(i3.3,' ',66a)") pole(k),'   ',title(1:66)
c$$$         write(12,"(i3.3,' ',66a)") pole(k),'   ',title(1:66)
c$$$
c$$$         print*,'POLE = ',pole(k)
         write(*,"(a5,' ',66a)") nomen,'   ',title(1:66)
         write(12,"(a5,' ',66a)") nomen,'   ',title(1:66)

         write(*,1332) nomen,delth,rm,delom,pm,iw,jw
     &        ,(iper(i),i=1,3),iavg,ngr,seclab,label
!         print*,'POLE = ',nomen
c     print*,'pm= ',pm, ' IAVG= ',iavg
c$$$  outfile=afile(1:(kk-1))//'.pf_title'//digit
c$$$  open(13,file=outfile,status='unknown')
c$$$  write(13,"('310 -20 25 0 1 LT ',i4)") pole(k)
c$$$  write(*,"('310 -20 25 0 1 LT ',i4)") pole(k)
c$$$  close(13)

         write(*,*) 'reading pole figure ',k
         kazimuth=0
         if(pm.eq.90.) kazimuth=1 !  one quadrant
         if(pm.eq.180.) kazimuth=2 !  one quadrant
         if(pm.eq.360.) kazimuth=4 !  four quadrants
         if(kazimuth.eq.0) stop 'cannot deal with that range!'

c     print*,'kazimuth= ',kazimuth

         scalef = 100./float(iavg)
c     print*,'scalef= ',scalef
         rescale=(abs(scalef-1.0).gt.0.05)
         print*,'rescale = ',rescale
         if(rescale) write(*,*) 'Rescaling intensities for k=',k,scalef
c     re-scale all the intensities in the section by the ratio
c     of the nominal average (100) divided by IAVG in the file
c     but require more than a 5% change to do it

         do j = 1,19
c$$$            print*,'j= ',j
            if (kazimuth.eq.1) then
!               read( 11 , 31 ,err=932)(nvint(i,j,k),i=1,19)
               read( 11 , 31 ) ( nvint(i,j,k) , i = 1 , 19 )
 31            format(1x,19i4)
               do i = 1,18
                  nvint((38-i),j,k) = nvint(i,j,k)
                  nvint((36+i),j,k) = nvint(i,j,k)
                  nvint((74-i),j,k) = nvint(i,j,k)
               enddo
            elseif(kazimuth.eq.2) then
!               read(11,"(1x,18i4)",err=932)(nvint(i,j,k),i=1,37)
               read( 11 , "(1x,18i4)" ) ( nvint(i,j,k) , i = 1 , 18 )
               read( 11 , "(1x,18i4)" ) ( nvint(i,j,k) , i = 19 , 36 )
!  split into two, to avoid the problem of the extra (average) number
!    at the end of the 4th line
c$$$               write( * , "(1x,18i4)" ) ( nvint(i,j,k) , i = 1 , 18 )
c$$$               write( * , "(1x,18i4)" ) ( nvint(i,j,k) , i = 19 , 36 )
               do i = 1,36
                  nvint((74-i),j,k) = nvint(i,j,k)
               enddo
            elseif(kazimuth.eq.4) then
!               read(11,"(1x,18i4)",err=932)(nvint(i,j,k),i=1,72)
               read( 11 , "(1x,18i4)" ) ( nvint(i,j,k) , i = 1 , 18 )
               read( 11 , "(1x,18i4)" ) ( nvint(i,j,k) , i = 19 , 36 )
               read( 11 , "(1x,18i4)" ) ( nvint(i,j,k) , i = 37 , 54 )
               read( 11 , "(1x,18i4)" ) ( nvint(i,j,k) , i = 55 , 72 )
               nvint(73,j,k) = nvint(1,j,k)
            endif
!     print*,'ready to rescale, perhaps'

            do i=1,73
               if(nvint(i,j,k).gt.intmax) intmax = nvint(i,j,k)
            enddo

         enddo                  !  j

!     new_scale = scalef * 3. / float(intmax) 
         new_scale = scalef / 100. 
         rescale = .true.
         

         do j = 1,19
            do i = 1,73
!     print*,'i= ',i,float(nvint(i,j,k))
!     if(rescale) then
               fint(i,j,k)=float(nvint(i,j,k))*new_scale
               if(fint(i,j,k).gt.ymax) 
     &              ymax = fint(i,j,k)
               if(fint(i,j,k).lt.ymin) 
     &              ymin = fint(i,j,k)
               yave = yave + fint(i,j,k)*darea(j)/tota
!  see above for dA correction
               count = count + 1
c     else
c     fint(i,j,k) = float(nvint(i,j,k))
c     endif
c     fixed line above to use SCALEF (was SCALE!)  Dec. 01
            enddo		!  i=1,73
c     print*,'now write out the intensities'

            do i = 1 , 73
               if ( fint(i,j,k).le.0. ) fint(i,j,k) = 1.
! *****  fix to avoid having GMT contour around zero 
               write(12,"(3(2x,g10.4))") 
c     1              float(i-1)*5.,float(j-1)*5.,fint(i,j,k)
     1              float(i-1)*5.,(90.-float(j-1)*5.),fint(i,j,k)
c  have to take 90-elevation to put zero on the GMT equator
            enddo

 724     enddo                  !  j=1,19

         read(11,*)		!  blank line at end of file
         close(12)

         yave = yave / float(count)
         print*,'  Minimum,  Average,  Maximum values :'
         print"(3(1x,g12.3))",ymin,yave,ymax
      enddo			!  k = 1,9
      
      goto 999

 932  print*,'error in reading from file'
      goto 999

 804  print*,'end of input file detected'
      goto 999

 999  call exit(0)
      end
